# sweep_api
API definitions for the Sweep server/dashboard.

This Dart package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 1.0.0-oas3
- Build package: org.openapitools.codegen.languages.DartClientCodegen

## Requirements

Dart 1.20.0 or later OR Flutter 0.0.20 or later

## Installation & Usage

### Github
If this Dart package is published to Github, please include the following in pubspec.yaml
```
name: sweep_api
version: 1.0.0
description: OpenAPI API client
dependencies:
  sweep_api:
    git: https://github.com/GIT_USER_ID/GIT_REPO_ID.git
      version: 'any'
```

### Local
To use the package in your local drive, please include the following in pubspec.yaml
```
dependencies:
  sweep_api:
    path: /path/to/sweep_api
```

## Tests

TODO

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```dart
import 'package:sweep_api/api.dart';

// TODO Configure API key authorization: api_key
//defaultApiClient.getAuthentication<ApiKeyAuth>('api_key').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('api_key').apiKeyPrefix = 'Bearer';

var api_instance = new EventApi();
var eventRequestBody = new EventRequestBody(); // EventRequestBody | 
var apiKey = apiKey_example; // String | 

try {
    api_instance.addEvent(eventRequestBody, apiKey);
} catch (e) {
    print("Exception when calling EventApi->addEvent: $e\n");
}

```

## Documentation for API Endpoints

All URIs are relative to *https://app.sweephq.com/1.0.0*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*EventApi* | [**addEvent**](docs\/EventApi.md#addevent) | **POST** /events | Raise an event
*EventApi* | [**getEventById**](docs\/EventApi.md#geteventbyid) | **GET** /events/{eventId} | Find raised event by ID
*EventApi* | [**listEvents**](docs\/EventApi.md#listevents) | **GET** /events | List all received events
*ListenerApi* | [**addListener**](docs\/ListenerApi.md#addlistener) | **POST** /listeners | Create a new Listener
*ListenerApi* | [**addListenerTemplate**](docs\/ListenerApi.md#addlistenertemplate) | **POST** /listeners/{listenerId}/templates/{templateId} | Associates a Template to a Listener
*ListenerApi* | [**deleteListener**](docs\/ListenerApi.md#deletelistener) | **DELETE** /listeners/{listenerId} | Deletes a Listener
*ListenerApi* | [**deleteListenerTemplate**](docs\/ListenerApi.md#deletelistenertemplate) | **DELETE** /listeners/{listenerId}/templates/{templateId} | Disassociates a Template from a Listener
*ListenerApi* | [**getListener**](docs\/ListenerApi.md#getlistener) | **GET** /listeners/{listenerId} | Get a listener by ID
*ListenerApi* | [**listListenerTemplates**](docs\/ListenerApi.md#listlistenertemplates) | **GET** /listeners/{listenerId}/templates | List Templates for Listener
*ListenerApi* | [**listListeners**](docs\/ListenerApi.md#listlisteners) | **GET** /listeners | List all Listeners
*ListenerApi* | [**listMessagesForAction**](docs\/ListenerApi.md#listmessagesforaction) | **GET** /actions/{listenerActionId}/messages | List all messages
*ListenerApi* | [**updateListener**](docs\/ListenerApi.md#updatelistener) | **PUT** /listeners/{listenerId} | Updates a Listener
*MessageApi* | [**getMessageById**](docs\/MessageApi.md#getmessagebyid) | **GET** /messages/{messageId} | Find message by ID
*MessageApi* | [**listMessages**](docs\/MessageApi.md#listmessages) | **GET** /messages | List all messages
*OrganizationApi* | [**getOrganizationInfo**](docs\/OrganizationApi.md#getorganizationinfo) | **GET** /organization | Get organization info for the currently authenticated context
*TemplateApi* | [**addTemplate**](docs\/TemplateApi.md#addtemplate) | **POST** /templates | Create a new Template
*TemplateApi* | [**deleteTemplate**](docs\/TemplateApi.md#deletetemplate) | **DELETE** /templates/{templateId} | Deletes a Template
*TemplateApi* | [**getTemplateById**](docs\/TemplateApi.md#gettemplatebyid) | **GET** /templates/{templateId} | Find Template by ID
*TemplateApi* | [**listTemplate**](docs\/TemplateApi.md#listtemplate) | **GET** /templates | List all Templates
*TemplateApi* | [**renderTemplate**](docs\/TemplateApi.md#rendertemplate) | **POST** /templates/{templateId}/render | Renders a template using the provided event parameters
*TemplateApi* | [**updateTemplate**](docs\/TemplateApi.md#updatetemplate) | **PUT** /templates/{templateId} | Update an existing Template
*UserApi* | [**deleteUser**](docs\/UserApi.md#deleteuser) | **DELETE** /user | Delete user
*UserApi* | [**getUserInfo**](docs\/UserApi.md#getuserinfo) | **GET** /user | Get user info for the currently authenticated user
*UserApi* | [**loginUser**](docs\/UserApi.md#loginuser) | **GET** /user/login | Logs user into the system
*UserApi* | [**logoutUser**](docs\/UserApi.md#logoutuser) | **GET** /user/logout | Logs out current logged in user session
*UserApi* | [**updateUser**](docs\/UserApi.md#updateuser) | **PUT** /user | Updated user


## Documentation For Models

 - [BaseMessage](docs\/BaseMessage.md)
 - [Event](docs\/Event.md)
 - [EventRequestBody](docs\/EventRequestBody.md)
 - [Listener](docs\/Listener.md)
 - [ListenerAction](docs\/ListenerAction.md)
 - [ListenerRequestBody](docs\/ListenerRequestBody.md)
 - [ListenerTemplate](docs\/ListenerTemplate.md)
 - [Message](docs\/Message.md)
 - [Organization](docs\/Organization.md)
 - [RenderTemplateRequestBody](docs\/RenderTemplateRequestBody.md)
 - [Template](docs\/Template.md)
 - [TemplateRequestBody](docs\/TemplateRequestBody.md)
 - [User](docs\/User.md)
 - [UserRequestBody](docs\/UserRequestBody.md)


## Documentation For Authorization


## GitHub

- **Type**: OAuth
- **Flow**: accessCode
- **Authorization URL**: https://github.com/login/oauth/authorize2
- **Scopes**: 
 - **user:email**: access your e-mail address

## Google

- **Type**: OAuth
- **Flow**: accessCode
- **Authorization URL**: https://accounts.google.com/o/oauth2/v2/auth
- **Scopes**: 
 - **https://www.googleapis.com/auth/userinfo.email**: access your e-mail address

## api_key

- **Type**: API key
- **API key parameter name**: api_key
- **Location**: HTTP header


## Author

contact@avinium.com


